C  Common definitions for nb3dsw.fcm
C  Everything is in common block /NBODY/
C  This file includes nb3dsw.hp, which defines the parameter N.

      INCLUDE 'nb3dsw.hp'

C  Arrays for problem representation, subscripted from 0!
C  x0, x1 - Current, new positions;      v0, v1 - velocities
C  m - mass;      mj - scaled mass;      ac - accelerations
C  w - working

      real, array(0:2, 0:N-1, 0:N-1) :: x0, x1, v0, v1, m, mj
      real, array(0:2, 0:N-1, 0:N-1) :: ac, d0, r0, ax, w
CMF$  LAYOUT x0(,,), x1(,,), v0(,,), v1(,,), m(,,), mj(,,)
CMF$  LAYOUT ac(,,), d0(,,), r0(,,), ax(,,), w(,,)
      COMMON /NBODY/ x0, x1, v0, v1, m, mj, ac, d0, r0, ax, w

C  i - row number;    j - column number;    c - coordinate number

      integer, array(0:2, 0:N-1, 0:N-1) :: i, j, c
CMF$  LAYOUT i(,,), j(,,), c(,,)
      COMMON /NBODY/ i, j, c

C  diag - processor represents actual particle
C  act  - processor is active pair
C  sm   - diag or act

      logical, array(0:2, 0:N-1, 0:N-1) :: diag, act, sm
CMF$  LAYOUT diag(,,), act(,,), sm(,,)
      COMMON /NBODY/ diag, act, sm
